<?php

namespace Canope\EdelegueBundle\Controller;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;

use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Canope\EdelegueBundle\Entity\Chapter;
use Canope\EdelegueBundle\Entity\Paragraph;
use Canope\EdelegueBundle\Form\ParagraphType;

/**
 * Paragraph controller.
 *
 * @Route("/paragraphe")
 */
class ParagraphController extends Controller
{
	/**
	 * Displays a form to edit an existing Paragraph entity.
	 *
	 * @Route("/{id}/edit", name="paragraph_edit")
	 * @Method({"GET", "POST"})
	 */
	public function editAction(Request $request, Paragraph $paragraph)
	{
		$deleteForm = $this->createDeleteForm($paragraph);
		$editForm = $this->createForm('Canope\EdelegueBundle\Form\ParagraphEditType', $paragraph);
		$editForm->handleRequest($request);

		if ($editForm->isSubmitted() && $editForm->isValid()) {
			$em = $this->getDoctrine()->getManager();
			$em->persist($paragraph);
			$em->flush();

			return $this->redirectToRoute('chapter_show', array('id' => $paragraph->getChapter()->getId()));
		}

		return $this->render('CanopeEdelegueBundle::paragraph/edit.html.twig', array(
			'paragraph' => $paragraph,
			'edit_form' => $editForm->createView(),
			'delete_form' => $deleteForm->createView(),
		));
	}
}
