<?php

namespace Canope\EdelegueBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;

use Canope\EdelegueBundle\Repository\ChapterRepository;

class ParagraphEditType extends AbstractType
{
    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {

        // Récupération d'un élément de l'entité dans une variable
        $idbook = $builder->getData()->getChapter()->getBook()->getId();
        
        $builder
            ->add('chapter', EntityType::class, array(
                'required' => false,
                'label' => 'Chapitres',
                'class' => 'CanopeEdelegueBundle:Chapter',
                'multiple' => false,
                'expanded' => true,
                'placeholder' => false,

                'choice_label' => 'name',
                // Affichage pour vérifier qu'on a la bonne variable
                // 'choice_label' => function ($chapter) {
                //     return $chapter->getName().' '.$chapter->getBook()->getId();
                // },

                // Utilisation de la variable dans le query_builder
                'query_builder' => function(ChapterRepository $chapter) use($idbook) {
                    // Utilisation de la fonction dans le buildForm
                    // return $chapter
                    //     ->createQueryBuilder('c')
                    //     ->where('c.book = :idbook')
                    //     ->setParameter('idbook', $idbook)
                    // ;

                    // Utilisation de la même fonction du ChapterRepository.php
                    return $chapter->getChaptersSameBook($idbook);
                },
            ))
        ;
    }

    public function getParent()
    {
        return ParagraphType::class;
    }
    
    /**
     * @param OptionsResolver $resolver
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'Canope\EdelegueBundle\Entity\Paragraph'
        ));
    }
}
